// polymorphic queue main

#include "book.h"
#include "aqueue.h"
#include "lqueue.h"

int main()
{
    Queue<int> *arrayOfQueues[2];
    arrayOfQueues[0] = new AQueue<int>(10);
    arrayOfQueues[1] = new LQueue<int>;

    for(int i = 0; i < 2; i++)
    {
        cout << "Iteration: " << i << endl << endl;
        int temp;
        arrayOfQueues[i]->enqueue(10);
        arrayOfQueues[i]->enqueue(20);
        arrayOfQueues[i]->enqueue(15);
        cout << "Length is " << arrayOfQueues[i]->length() << endl;

        if(arrayOfQueues[i]->length() > 0)
        {
            temp = arrayOfQueues[i]->frontValue();
            cout << "Front is " << temp << endl;
        }
        else cout << "Nothing in queue\n";

        while(arrayOfQueues[i]->length() > 0)
        {
            temp = arrayOfQueues[i]->dequeue();
            cout << temp << " ";
        }

        cout << endl;
        cout << "Length is " << arrayOfQueues[i]->length() << endl;

        if(arrayOfQueues[i]->length() > 0)
        {
            temp = arrayOfQueues[i]->frontValue();
            cout << "Front is " << temp << endl;
        }
        else cout << "Nothing in queue\n";

        arrayOfQueues[i]->clear();

        cout << "Length is " << arrayOfQueues[i]->length() << endl;
        cout << "That is all." << endl << endl << endl;
    }

    return 0;
}
