// Simple palindrome detector

#include "book.h"
#include "lstack.h"
#include "lqueue.h"
#include <string>

using std::cin;

bool isPalindrome()
{
    LQueue<char> QObj;
    LStack<char> SObj;

    char letter;
    int mismatches = 0;
    bool success;

    int i;
    char next;
    char discard;
    bool failed;

    cout << "Enter a word or phrase: ";

    while(cin.peek() !=  '\n')
    {
        cin >> letter;
        if(isalpha(letter))
        {
            QObj.enqueue(toupper(letter));
            SObj.push(toupper(letter));
        }
    }

    while((QObj.length() > 0) && (SObj.length() > 0))
    {
        if(QObj.dequeue() != SObj.pop())
        {
            mismatches++;
            break;
        }
    }

    // Boolean means what here?
    if(mismatches)
    {
        cout << "It was not a palindrome." << endl;

        success = true;
    }
    else
    {
        cout << "It was a palindrome." << endl;
        success = false;
    }

    return success;
}

int main()
{
    isPalindrome();

    return 0;
}
